// ---------------------------------------------------------------------------
// Simple RegExp
//
//                                                 copyright (c) kanegon 2009
// ---------------------------------------------------------------------------

#pragma once

#include <tchar.h>
#include <windows.h>
#include <comdef.h>
#include <exception>
#include <string>
#include "xstr.h"

#import "vbscript_regexp_55.tlb" no_namespace


//////////////////////////////////////////////////////////////////////////////

class regexp_exception: public std::exception {
public:
	regexp_exception() {}
	regexp_exception(const char* const &message) : std::exception(message) {}
};


//////////////////////////////////////////////////////////////////////////////

class SimpleRegExp {
private:
	IRegExp2Ptr m_pRegExp;
	IMatchCollection2Ptr m_pMatches;
	IMatch2Ptr m_pMatch;
	ISubMatchesPtr m_pSubMatches;

public:
	SimpleRegExp() {
		Clear();
	}
	virtual ~SimpleRegExp() {
		Clear();
	}

public:
	BOOL Test(LPCTSTR pszText, LPCTSTR pszRegExp, LPCTSTR pszOption=NULL);
	BOOL Match(LPCTSTR pszText, LPCTSTR pszRegExp, LPCTSTR pszOption=NULL);
	xstr_t Replace(LPCTSTR pszText, LPCTSTR pszReplaceText, LPCTSTR pszRegExp, LPCTSTR pszOption=NULL);
	int GetMatchCount();
	BOOL SelectMatch(int index);
	xstr_t GetMatchText(int index=0);

private:
	void InitRegExp(LPCTSTR pszRegExp, LPCTSTR pszOption);
	void Clear() {
		m_pSubMatches = NULL;
		m_pMatch = NULL;
		m_pMatches = NULL;
		m_pRegExp = NULL;
	}
};

