
#pragma warning (disable: 4995 4996)


#include <tchar.h>
#include <stdio.h>
#include <locale.h>
#include <windows.h>
#include "SimpleRegExp.h"


using namespace std;


void test()
{
	try {
		SimpleRegExp re;

		if (re.Test(_T("AA123"), _T("[A-Za-z]+\\d+"))) {
			_tprintf(_T("test1: T\n"));
		}
		else {
			_tprintf(_T("test1: F -- ng\n"));
		}

		if (re.Test(_T("123ZZ"), _T("[A-Za-z]+\\d+"), _T(""))) {
			_tprintf(_T("test2: T -- ng\n"));
		}
		else {
			_tprintf(_T("test2: F\n"));
		}
	}
	catch (const exception& e) {
		_tprintf(_T("exception occurred: %s\n"), (LPCTSTR)_bstr_t(e.what()));
	}
}

void match()
{
	try {
		SimpleRegExp re;

		if (re.Match(_T("ZZ100"), _T("(\\w+)(\\d+)"), _T(""))) {
			TCHAR sz[256];
			_sntprintf(sz, sizeof(sz) / sizeof(TCHAR), _T("%s, %s, %s"),
					re.GetMatchText(0).c_str(), re.GetMatchText(1).c_str(), re.GetMatchText(2).c_str());
			if (_tcscmp(sz, _T("ZZ100, ZZ10, 0")) == 0) {
				_tprintf(_T("match1: %s\n"), sz);
			}
			else {
				_tprintf(_T("match1: %s -- ng\n"), sz);
			}
			_tprintf(_T("%s, %s, %s\n"),
					re.GetMatchText(1).c_str(), re.GetMatchText(2).c_str(), re.GetMatchText(3).c_str());
		}
		else {
			_tprintf(_T("match1: no match -- ng\n"));
		}

		if (re.Match(_T("ZZ100"), _T("[0-9]+([A-Z]+)"), _T(""))) {
			TCHAR sz[256];
			_sntprintf(sz, sizeof(sz) / sizeof(TCHAR), _T("%s, %s"),
					re.GetMatchText(0).c_str(), re.GetMatchText(1).c_str());
			_tprintf(_T("match2: %s -- ng\n"), sz);
		}
		else {
			_tprintf(_T("match2: no match\n"));
		}

		if (re.Match(_T("A1BB22CCC333DDDD4444"), _T("([a-z])[0-9]([0-9])"), _T("ig"))) {
			xstr_t str;
			int cc = re.GetMatchCount();
			for (int i = 0; i < cc; i++) {
				re.SelectMatch(i);
				str += re.GetMatchText(1) + re.GetMatchText(2);
			}
			if (_tcscmp(str.c_str(), _T("B2C3D4")) == 0) {
				_tprintf(_T("match3: %s\n"), str.c_str());
			}
			else {
				_tprintf(_T("match3: %s -- ng\n"), str.c_str());
			}
		}
		else {
			_tprintf(_T("match3: no match -- ng\n"));
		}
	}
	catch (const exception& e) {
		_tprintf(_T("exception occurred: %s\n"), (LPCTSTR)_bstr_t(e.what()));
	}
}

void replace()
{
	try {
		SimpleRegExp re;

		xstr_t str = re.Replace(_T("ZZ345"), _T("@$1$1@"), _T("[A-Z]([0-9])[0-9]"), NULL);
		if (_tcscmp(str.c_str(), _T("Z@33@5")) == 0) {
			_tprintf(_T("replace1: %s\n"), str.c_str());
		}
		else {
			_tprintf(_T("replace1: %s -- ng\n"), str.c_str());
		}
	}
	catch (const exception& e) {
		_tprintf(_T("exception occurred: %s\n"), (LPCTSTR)_bstr_t(e.what()));
	}
}

int _tmain(int argc, TCHAR* argv[])
{
	_tsetlocale(LC_ALL, _T(""));
	CoInitialize(NULL);

	test();
	match();
	replace();

	CoUninitialize();
	return 0;
}
